Topology
Base URL: $BUSINESS_API
The object
idtenant_idnode_codenamenode_typeone of
source_river,source_borehole,treatment_plant,reservoir,dma_inlet,junction,customer_tapelevation_metersstorage_capacity_m3latitudelongitudeactiveservice_area_iddma_iddevice_idLevel or flow device reporting measurements
meter_idCustomer meter attributed to a customer_tap
meter_serialSerial number of the referenced meter. Omitted when unknown.
meter_holder_nameDisplay name of the customer who holds the account the meter is installed on. Omitted when unknown.
created_atupdated_at
Endpoints
- GET
/topology/nodes - POST
/topology/nodes - GET
/topology/nodes/{id} - PUT
/topology/nodes/{id} - DELETE
/topology/nodes/{id} - GET
/topology/links - POST
/topology/links - GET
/topology/links/{id} - PUT
/topology/links/{id} - DELETE
/topology/links/{id} - GET
/topology/trace/upstream - GET
/topology/trace/downstream - GET
/topology/trace/valve-isolation - GET
/topology/balance/dma/{id} - POST
/topology/balance/dma/{id}/ledger - GET
/topology/balance/ledger
The object
{
"id": "top_20EbJqgt7ECLvqS5fuUZFei3bys",
"tenant_id": "ten_2ugFXIC316WXzGu1HGal90AxTA6",
"node_code": "NOD-2026-000142",
"name": "Ana Matsinhe",
"node_type": "source_river",
"elevation_meters": 1,
"storage_capacity_m3": 1,
"latitude": -25.9653,
"longitude": 32.5892,
"active": true,
"service_area_id": "ser_23fmkpfkC17kSVJ2spjyiBbOED9",
"dma_id": "dma_2gE3tiwbLQQnDGcrVkstPO8Bjkg",
"device_id": "dev_2E2J9iiRr2o7PWMrj8wJrQyb9sK",
"meter_id": "mtr_21F02THKOD7uMpvUalZKsBv64nN",
"meter_serial": "meter serial",
"meter_holder_name": "Ana Matsinhe",
"created_at": "2026-11-19T09:30:00Z",
"updated_at": "2026-11-19T09:30:00Z"
}- NodesList network graph nodes · Create topology node · Get a graph node · Update a graph node …5 operations
- LinksList network graph links · Create a directed link · Get a link · Update a link …5 operations
- TraceNodes and links feeding a node · Nodes and links fed by a node · Trace valve isolation3 operations
- BalanceCompute a DMA water balance over [from, to) · Record a closed period's balance in the immutable ledger · List mass balance ledger rows, newest first3 operations